SetLiftUpDownStateEvent = {};
SetLiftUpDownStateEvent_mt = Class(SetLiftUpDownStateEvent, Event);

InitEventClass(SetLiftUpDownStateEvent, "SetLiftUpDownStateEvent");

function SetLiftUpDownStateEvent:emptyNew()
    local self = Event:new(SetLiftUpDownStateEvent_mt);
    self.className = "SetLiftUpDownStateEvent";
    return self;
end;

function SetLiftUpDownStateEvent:new(object, idx, up, down)
    local self = SetLiftUpDownStateEvent:emptyNew()
    self.object = object;
	self.idx = idx;
	self.up = up;
	self.down = down;
    return self;
end;

function SetLiftUpDownStateEvent:readStream(streamId, connection)
    local id = streamReadInt32(streamId);
	self.object = networkGetObject(id);
	self.idx = streamReadUInt8(streamId);
	self.up = streamReadBool(streamId);
	self.down = streamReadBool(streamId);
    self:run(connection);
end;

function SetLiftUpDownStateEvent:writeStream(streamId, connection)
    streamWriteInt32(streamId, networkGetObjectId(self.object));
	streamWriteUInt8(streamId, self.idx);
	streamWriteBool(streamId, self.up);
	streamWriteBool(streamId, self.down);
end;

function SetLiftUpDownStateEvent:run(connection)
	self.object:setLiftUpDownState(self.idx, self.up, self.down, true);
	if not connection:getIsServer() then
		g_server:broadcastEvent(SetLiftUpDownStateEvent:new(self.object, self.idx, self.up, self.down), nil, connection, self.object);
	end;
end;

function SetLiftUpDownStateEvent.sendEvent(vehicle, idx, up, down, noEventSend)
	if noEventSend == nil or noEventSend == false then
		if g_server ~= nil then
			g_server:broadcastEvent(SetLiftUpDownStateEvent:new(vehicle, idx, up, down), nil, nil, vehicle);
		else
			g_client:getServerConnection():sendEvent(SetLiftUpDownStateEvent:new(vehicle, idx, up, down));
		end;
	end;
end;


